type ast =
  | Plus of ast * ast
  | Fois of ast * ast
  | Cte of int
  | Id of string
  | LetIn of string * ast * ast
  | Fun of string * ast
  | App of ast * ast
         
let print_sep l =
  List.iter print_string l

let rec print_sep_spec = function
  | [] -> ()
  | [x] -> print_string "|-"
  | x :: q -> print_string x; print_sep_spec q
    
let rec aff_aux l a =
  print_sep_spec l;
  match a with
  | Plus(a1, a2) ->
     print_string "Plus\n";
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["| "]) a1;
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["  "]) a2
  | Fois(a1, a2) ->
     print_string "Fois\n";
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["| "]) a1;
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["  "]) a2
  | LetIn(x, a1, a2) ->
     print_string "LetIn\n";
     print_sep (l @ ["|\n"]);
     print_sep_spec (l @ [""]);
     print_endline x;
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["| "]) a1;
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["  "]) a2
  | Fun(x, a1) ->
     print_string "Fun\n";
     print_sep (l @ ["|\n"]);
     print_sep_spec (l @ [""]);
     print_endline x;
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["  "]) a1
  | App(a1, a2) ->
     print_string "App\n";
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["| "]) a1;
     print_sep (l @ ["|\n"]);
     aff_aux (l @ ["  "]) a2
  | Cte i -> Printf.printf "Cte(%i)\n" i
  | Id s -> Printf.printf "Id(%s)\n" s

let affiche = aff_aux []
  
