let rec check_scope_aux : Ast.ast -> string list -> bool =
  fun a vars ->
  match a with
    Plus(a1, a2)| Fois(a1, a2) | App(a1, a2)
                  -> check_scope_aux a1 vars && check_scope_aux a2 vars
  | Cte _ -> true
  | Id x -> List.mem x vars
  | LetIn(x, a1, a2) ->
     check_scope_aux a1 vars && check_scope_aux a2 (x::vars)
  | Fun(x, a1) ->
     check_scope_aux a1 (x::vars)


let check_scope : Ast.ast -> bool =
  fun a -> check_scope_aux a []



let lexbuf = Lexing.from_channel stdin

let _ =
  while true do
    let a = Parser.s (Lexer.decoupe) lexbuf in
    Ast.affiche a;
    if check_scope a then print_endline "Portée correcte"
    else print_endline "Portée incorrecte";
    print_newline ()
  done
